module.exports = {
  root: true,
  env: {
    node: true,
  },
  extends: [
    'plugin:vue/recommended',
    '@vue/airbnb',
    '@vue/typescript',
  ],
  rules: {
    'no-console': process.env.NODE_ENV === 'production' ? 'error' : 'warn',
    'no-debugger': process.env.NODE_ENV === 'production' ? 'error' : 'warn',
    semi: 'off', // disable the base rule as it can report incorrect errors
    '@typescript-eslint/semi': ['error'],
    'import/prefer-default-export': 0,
    'max-len': ['error', { code: 120 }],
  },
  parserOptions: {
    parser: '@typescript-eslint/parser',
  },
};
