<?php
set_time_limit(50000);
ini_set('max_execution_time',50000);
$limit = (int) $_GET['limit'];
$host = 'mysql';
$user = 'root';
$pass = 'pa195';
$dbname = "pa195";
$conn = mysqli_connect($host, $user, $pass, $dbname);

$file = fopen("data/LetsEncrypt.csv","r");
$sql = array();
$rows = 0;

$resultSQL = $conn->query('DELETE FROM PerfTest');

$timeStart = microtime(true);
while(! feof($file) && $rows !== $limit) {
    $row = explode(",", fgets($file));
    #$sql[] = "('" . $row[0] . "', '" . $row[1] . "', '" . $row[2] . "', '" . $row[3] . "')";
    $resultSQL = $conn->query('INSERT INTO PerfTest (CertAuthURL, Domain, CertAuth, LogType) VALUES ' . "(" . $row[0] . ", " . $row[1] . ", " . $row[2] . ", " . $row[3] . ")");
    $rows = $rows +1;
}
fclose($file);
$timeEnd = microtime(true);
$timeMySQL = $timeEnd - $timeStart;

require("aws/aws-autoloader.php");
use Aws\DynamoDb\Exception\DynamoDbException;

$params = $_GET['params'];
$sdk = new Aws\Sdk([
        'endpoint'  => 'http://dynamodb-local:8000',
        'region'    => 'eu-central-1',
        'version'   => 'latest',
        'credentials' => [
                'key' => 'AKIASNAN4NLHAWWHDQ2F',
                'secret' => '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'
        ]
]);

$dynamodb = $sdk->createDynamoDb();

try {
    $response = $dynamodb->createTable([
    'TableName' => 'PerfTest',
    'AttributeDefinitions' => [
        [
            'AttributeName' => 'LogType',
            'AttributeType' => 'S'
        ],
        [
            'AttributeName' => 'Domainn',
            'AttributeType' => 'S'
        ]
    ],
    'KeySchema' => [
        [
            'AttributeName' => 'Domainn',
            'KeyType' => 'HASH'
        ],
        [
            'AttributeName' => 'LogType',
            'KeyType' => 'RANGE'
        ]
    ],
    'ProvisionedThroughput' => [
        'ReadCapacityUnits'  => 25,
        'WriteCapacityUnits' => 25
    ]
    ]);
    $dynamodb->waitUntil('TableExists', [
        'TableName' => 'PerfTest',
        '@waiter' => [ 
            'delay'       => 5,
            'maxAttempts' => 20
        ]   
   ]); 
//    echo "Table PerfTest has been created.\n";
} catch (DynamoDbException $e) {
    // echo $e->getMessage() . "\n";
    echo $e;
    // exit ("Unable to create table $tableName\n");
}

$file = fopen("data/LetsEncrypt.csv","r");
$rows = 0;


$timeDynamoDB = 0;
while(! feof($file) && $rows !== $limit) {
    $row = explode(",", fgets($file));
    try {
        $timeStart = microtime(true);
        $response = $dynamodb->batchWriteItem([
            'RequestItems' => [
                'PerfTest' => [
                    [
                        'PutRequest' => [
                            'Item' => [
                                'CertAuthURL' => ['S' => $row[0]],
                                'Domainn' => ['S' => $row[1]],
                                'CertAuth'  => ['S' => $row[2]],
                                'LogType' => ['S' => $row[3]]
                            ]
                        ]
                    ]
                ]
            ]
        ]);
        $timeEnd = microtime(true);
        $timeDynamoDB += $timeEnd - $timeStart;       
    } catch (DynamoDbException $e) {
        echo $e->getMessage() . "\n";
        exit ("Unable to load data into $tableName\n");
    }
    $rows = $rows +1;
}
fclose($file);



$result = (object) array();
$result->rows = $limit;
$result->InsertMySQL = $timeMySQL;
$result->InsertDynamoDB = $timeDynamoDB;

$timeStart = microtime(true);
$certauth = "Let's Encrypt";
$resultSQL = $conn->query("SELECT * FROM PerfTest WHERE Domain = 'kimportfolio.me' AND LogType = 'X509LogEntry'");
$timeEnd = microtime(true);
$timeMySQL = $timeEnd - $timeStart;

$timeStart = microtime(true);
// $scan_response = $dynamodb->scan(array(
//     'TableName' => 'PerfTest' 
// ));
$response = $dynamodb->query(array(
    'TableName' => 'PerfTest',
    'KeyConditionExpression' => 'Domainn = :v_hash and LogType = :v_range',
    'ExpressionAttributeValues' =>  array (
        ':v_hash'  => array('S' => "kimportfolio.me"),
        ':v_range' => array('S' => 'X509LogEntry')
    )
));
$timeEnd = microtime(true);
$timeDynamoDB = $timeEnd - $timeStart;

$result->SelectMySQL = $timeMySQL;
$result->SelectDynamoDB = $timeDynamoDB;

try {
    $response = $dynamodb->deleteTable([
        'TableName' => 'PerfTest'
    ]);

    $dynamodb->waitUntil('TableNotExists', [
        'TableName' => 'PerfTest',
        '@waiter' => [
            'delay'       => 5,
            'maxAttempts' => 20
        ]
    ]);
    // echo "The table PerfTest has been deleted.\n";
} catch (DynamoDbException $e) {
    // echo $e->getMessage() . "\n";
    exit ("Unable to delete table PerfTest\n");
}

echo json_encode($result);
?>